/*
  作成者: ihara789
  作成日: 2023/12/01
  更新日: 2023/12/14
*/

// --------------------------------------------

// filed
let playfield_width = 600;
let playfield_height = 400;
let playfield_color = '#2c4f54'

// player
const player_width = 50;
const player_height = 50;
let player_x = (playfield_width - player_width) / 2;
let player_y = (playfield_height - player_width) / 2;
let player_color = '#80aba9'
let player_moving_size = 5;

const canvas = document.querySelector('#playfield');

// Field
class Playfield {
    constructor(canvas, x, y, width, height, color) {
        this.canvas = canvas;
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
        this.canvas.width = this.width;
        this.canvas.height = this.height;
    }
    draw() {
        const ctx = this.canvas.getContext('2d');
        ctx.fillStyle = this.color;
        ctx.fillRect(this.x, this.y, this.width, this.height);
    }
}

// player
class Player {
    constructor(canvas, x, y, width, height) {
        this.canvas = canvas;
        this.p_x = x;
        this.p_y = y;
        this.p_w = width;
        this.p_h = height;
        this.p_c = player_color;
    }
    draw() {
        const ctx = this.canvas.getContext('2d');
        ctx.beginPath();
        ctx.rect(this.p_x, this.p_y, this.p_w, this.p_h);
        ctx.fillStyle = this.p_c;
        ctx.fill();
        ctx.closePath();
    }
    move(dx, dy) {
        this.p_x += dx;
        this.p_y += dy;
        this.draw();
      }
}

//---------------------- control--------------------------

// （key input） ----------------------
document.addEventListener("keydown", (event) => {
    if (event.code === "ArrowUp") {
        console.log(event.code);
        player.move(0, -10);
    };
    if (event.code === "ArrowDown") {
        console.log(event.code);
        player.move(0, 10);
    };
    if (event.code === "ArrowLeft") {
        console.log(event.code);
        player.move(-10, 0);
    };
    if (event.code === "ArrowRight") {
        console.log(event.code);
        player.move(10, 0);
    };
    if (event.code === "Space") {
        console.log(event.code);
    }

    player.draw();
});

//---------------------- control--------------------------

// Field | Rendering
const playfield = new Playfield(canvas, 0, 0, playfield_width, playfield_height, playfield_color);
playfield.draw();

// player | Rendering
const player = new Player(canvas, player_x, player_y, player_width, player_height);

const interval = setInterval(() => {
    playfield.draw();
    player.draw();
  }, 1000 / 60);